pexplosion = GetIntParam("power", 6)
pactive = GetBoolParam("active", false) 
pdefuse = GetBoolParam("defusable", true)
function init()

	button = FindShape("button")
	light = FindLight("light")
	mine = FindShape("mine")
	SetTag(button, "interact", "activate")
	activatesound = LoadSound("/snd/beep1.ogg")
	deactivatesound = LoadSound("/snd/beep2.ogg")
	bombbeep = LoadLoop("/snd/bombbeep.ogg")
	activated = false 
	bombtrigger = FindTrigger("bombtrigger")
	
	
	triggerlocation = GetShapeWorldTransform(mine)
	triggerLocalT = TransformToLocalTransform(triggerlocation , GetTriggerTransform(bombtrigger))
	detonated = false 
	SetLightEnabled(light, false)
	armed = false 
	armingtime = 0
	frame = 0
	if pdefuse == false then 
		RemoveTag(button, "interact", "activate")
	end 
end
	
	
	
	
	
	
function tick()
	pos = GetShapeWorldTransform(mine).pos
	--DebugWatch("activated", activated)
	triggerlocation = GetShapeWorldTransform(mine)
	SetTriggerTransform(bombtrigger, TransformToParentTransform(triggerlocation , triggerLocalT))
	currentshape = GetPlayerInteractBody()
	--DebugWatch("detonated", detonated)
	--DebugWatch("pactive", pactive)

	if pactive == true then 
		--DebugPrint("workingactivate")
		RemoveTag(button, "interact", "activate")
		if pdefuse == true then  
			SetTag(button,"interact", "deactivate")
		end 
		SetLightEnabled(light, true)
		--check1 = false
		--DebugWatch("pos", pos)
		Spawn("MOD/joint2.xml", Transform(pos), true, true)
		activated = true
		armingtime = GetTime()
		checktime = false 
		--pactive = false 
		armed = true 
	end
	
	if activated == false then
		SetLightEnabled(light, false)
	end
	
	
	if activated == true and armed == false then
		pos = GetShapeWorldTransform(mine).pos
		PlayLoop(bombbeep, pos, 1)
		frame = frame + 1
		SetLightEnabled(light, frame % 60 < 30)
	end
		
		
	
	
		
	if GetPlayerInteractShape() == button and InputPressed("interact") and pdefuse == true then
				--DebugPrint("working")
		if activated == false then
			--DebugPrint("workingactivate")
			RemoveTag(button, "interact", "activate")
			SetTag(button,"interact", "deactivate")
			SetLightEnabled(light, true)
			--check1 = false
				--DebugWatch("pos", pos)
			Spawn("MOD/joint2.xml", Transform(pos), true, true)
			activated = true
			armingtime = GetTime()
			checktime = true
		elseif  activated == true then
			--DebugPrint("workingdeactivate")
			RemoveTag(button, "interact", "deactivate")
			RemoveTag(button, "activated")
			SetTag(button,"interact", "activate")
			PlaySound(deactivatesound)
			SetLightEnabled(light, false)
			joint = FindJoint("c4joint")
			Delete(joint)
			activated = false
			armed = false
		end
	end
	timenow = GetTime()
	if pactive == false then 
		if timenow > armingtime + 2.2 and activated == true and checktime == true then 
			armed = true
			PlaySound(activatesound)
			checktime = false
			SetLightEnabled(light, true)
		end 
	end
		
	
	vehicles = FindVehicles("", true)
	--DebugWatch("vehicles", table.concat(vehicles, ", "))
	for i=1, #vehicles do
		if IsVehicleInTrigger(bombtrigger, vehicles[i]) == true and activated == true and armed == true then
			--DebugPrint("factos")
			--detonated = true 
			dbt = GetShapeWorldTransform(mine)
			Explosion(dbt.pos, pexplosion)
			activated = false
			Delete(button)
			Delete(joint)
			Delete(mine)
			Delete(light)
			Delete(bombtrigger)
		end
	end
	pactive = false 
	
	
end



